function varargout = Arduino_servo_simple(varargin)
% ARDUINO_SERVO_SIMPLE M-file for Arduino_servo_simple.fig
%      ARDUINO_SERVO_SIMPLE, by itself, creates a new ARDUINO_SERVO_SIMPLE or raises the existing
%      singleton*.
%
%      H = ARDUINO_SERVO_SIMPLE returns the handle to a new ARDUINO_SERVO_SIMPLE or the handle to
%      the existing singleton*.
%
%      ARDUINO_SERVO_SIMPLE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ARDUINO_SERVO_SIMPLE.M with the given input arguments.
%
%      ARDUINO_SERVO_SIMPLE('Property','Value',...) creates a new ARDUINO_SERVO_SIMPLE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Arduino_servo_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Arduino_servo_simple_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Arduino_servo_simple

% Last Modified by GUIDE v2.5 12-Jan-2015 18:16:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Arduino_servo_simple_OpeningFcn, ...
                   'gui_OutputFcn',  @Arduino_servo_simple_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%
% --- Executes just before Arduino_servo_simple is made visible.
function Arduino_servo_simple_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Arduino_servo_simple (see VARARGIN)

clc;

% Choose default command line output for Arduino_servo_simple
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Arduino_servo_simple wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%%
% --- Outputs from this function are returned to the command line.
function varargout = Arduino_servo_simple_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%
% --- Executes on button press in Connect_pushbutton.
function Connect_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to Connect_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

comPort = 'COM3';

% check whether serial port is currently used by MATLAB
if ~isempty(instrfind({'Port'}, {comPort}))
    
    disp(['The port ' comPort ' is already used by MATLAB']);
    disp(['If you are sure that the board is connected to ' comPort]);
    disp('then delete the object, execute:');
    disp(['  delete(instrfind({''Port''},{''' comPort '''}))']);
    disp('to delete the port, disconnect the cable, reconnect it,');
    disp('and then create a new arduino object');
    error(['Port ' comPort ' already used by MATLAB']);
    
else

    a = serial(comPort, 'BaudRate', 115200);

    % open port
    try
        fopen(a);

        % it takes several seconds before any operation could be attempted
        fprintf(1, 'Attempting connection .');
        for i = 1:3
            pause(1);
            fprintf(1, '.');
        end
        fprintf(1, '\n');

        % flush serial buffer before sending anything
        flush(a);

        % query sketch type
        fwrite(a, [57 57], 'uchar');
        sketch = fscanf(a, '%d');

        % exit if there was no answer
        if isempty(sketch)
            delete(a);
            error('Connection unsuccessful, please make sure that the board is powered on, running a sketch provided with the package, and connected to the indicated serial port. You might also try to unplug and re-plug the USB cable before attempting a reconnection.');
        end

        % check returned value
        if sketch == 0
            disp('Basic Analog and Digital I/O (adio.ino) sketch detected!');
        elseif sketch == 1
            disp('Analog & Digital I/O + Encoders (adioe.ino) sketch detected!');
        elseif sketch == 2
            disp('Analog & Digital I/O + Encoders + Servos (adioes.ino) sketch detected!');
        elseif sketch == 3
            disp('Motor Shield V1 (plus adioes.ino functions) sketch detected!');
        elseif sketch == 4
            disp('Motor Shield V2 (plus adioes.ino functions) sketch detected!');
        elseif sketch == 5
            disp('Basic Analog and Digital I/O (adio.ino functions) + audio sketch detected!');
        else
            delete(a);
            error('Unknown sketch. Please make sure that a sketch provided with the package is running on the board');
        end

        % notify successful installation
        disp('Arduino successfully connected!');

        setappdata(gcf, 'SerialObject', a);

    catch
        delete(a);
        error(['Could not open port: ' comPort]);
    end
end

%%

function val = flush(a)

% val=flush(a) (or val=a.flush) reads all the bytes available 
% (if any) in the computer's serial port buffer, therefore 
% clearing said buffer.
% The first and only argument is the arduino object, the 
% output is a vector of bytes that were still in the buffer.
% The value '-1' is returned if the buffer was already empty.

val = -1;
if a.BytesAvailable > 0
    val = fread(a, a.BytesAvailable);
end


%%
% --- Executes on button press in Disconnect_pushbutton.
function Disconnect_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to Disconnect_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

a = getappdata(gcf, 'SerialObject');
disp('Disconnecting Arduino...');
deleteSer(a);

%%

% destructor, deletes the object
function deleteSer(a)

% Use delete(a) or a.delete to delete the arduino object

% if it is a serial, valid and open then close it
% check the class (isa)
if isa(a, 'serial') && isvalid(a) && strcmpi(get(a,'Status'),'open')
        try
            % trying to leave it in a known unharmful state
            for i = 2:69
                a = pinMode(a, i, 'output');
                digitalWrite(a, i, 0);
                a = pinMode(a, i, 'input');
            end
        catch
            % disp but proceed anyway
            disp('Could not sucesfully turn everything off.');
            disp('Proceeding to deletion anyway');
        end
    fclose(a);
end

% if it's an object delete it
if isobject(a),
    delete(a);
end

clc;
disp('Arduino successfully disconnected!');

%%
function digitalWrite(a, pin, val)

% digitalWrite(a, pin, val); performs digital output on a given pin.
% The first argument, a, is the arduino object.
% The second argument, pin, is the number of the digital pin 
% (2 to 69) where the digital output value needs to be written.
% The third argument, val, is the output value (either 0 or 1).
%
% On the Arduino Uno the digital pins from 0 to 13 are located
% on the upper right part of the board, while the digital pins
% from 14 to 19 are better known as "analog input" pins and are
% located in the lower right corner of the board  (in fact are 
% often referred to as "analog pins from 0 to 5").
%
% Examples:
% digitalWrite(a, 13, 1); % sets pin #13 high
% digitalWrite(a, 13, 0); % sets pin #13 low
% a.digitalWrite(13, 0); % just as above (sets pin #13 to low)


% send mode, pin and value
fwrite(a, [50 97+pin 48+val], 'uchar');

%%

% pin mode, changes pin mode
function a = pinMode(a, pin, str)

% pinMode(a, pin, str); reads or sets the I/O mode of a digital pin.
% The first argument, a, is the arduino object.
% The second argument, pin, is the number of the digital pin (2 to 69).
% The third argument, str, is a string that can be 'input' or 'output',
% Called as pinMode(a, pin) it returns the mode of the digital pin, 
% called as pinMode(a), it prints the mode of all the digital pins. 
%
% Note that in the Arduino Uno board the digital pins from 0 to 13 
% are located on the upper right part of the board,
% while the digital pins from 14 to 19 are better known as
% "analog input" pins (in fact are often referred to with an 
% analog pin number from 0 to 5) and are located in the lower 
% right corner of the board.
%
% Examples:
% pinMode(a, 11, 'output') % sets digital pin #11 as output
% pinMode(a, 10, 'input')  % sets digital pin #10 as input
% a.pinMode(10, 'input')   % same as pinMode(a,10,'input')
% val=pinMode(a, 10);      % returns the status of digital pin #10
% pinMode(a, 5);           % prints the status of digital pin #5
% pinMode(a);              % prints the status of all pins


% assign value - check if string is 'output'
if lower(str(1)) == 'o'
    val = 1;
else
    val = 0;
end

% send mode, pin and value
fwrite(a, [48 97+pin 48+val], 'uchar');

% silently detach servos on the corresponding pin
a = servoDetach(a, pin);

            
%%
% --- Executes on button press in ServoMove_pushbutton.
function ServoMove_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ServoMove_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

servo_channel = get(handles.ServoChannel_popupmenu, 'Value');
servo_angle = str2double(get(handles.ServoAngle_edit, 'String'));

a = getappdata(gcf, 'SerialObject');

a = servoAttach(a, servo_channel);

servoWrite(a, servo_channel, servo_angle);

% val = servoRead(a, servo_channel);

set(handles.Servo_slider, 'Value', servo_angle);

% a = servoDetach(a, servo_channel);

% make sure the serial object is stored again because it has changed
setappdata(gcf, 'SerialObject', a);


%%
function ServoAngle_edit_Callback(hObject, eventdata, handles)
% hObject    handle to ServoAngle_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ServoAngle_edit as text
%        str2double(get(hObject,'String')) returns contents of ServoAngle_edit as a double

%%
% --- Executes during object creation, after setting all properties.
function ServoAngle_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ServoAngle_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%

% --- Executes during object creation, after setting all properties.
function ServoChannel_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ServoChannel_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%

% servo attach
function a = servoAttach(a, pin)

% servoAttach(a,pin); or a.servoAttach(pin); attaches a servo to a pin.
% The first argument, a, is the arduino object. The second argument, 
% pin, is the number of the pwm pin where the servo must be attached 
% (a servo has three pins, a central red one which goes to +5V,
% a black or brown one which goes to ground, and a white or orange one 
% which must be connected to an analog output (PWM) pin on the Arduino).
%
% Earlier versions of both Arduino boards and Arduino IO package supported
% only pwm pins 9 and 10, now up to 12 different pins are supported on most
% Arduino boards, and 48 on the Mega. Note that on boards other than the Mega,
% use of the servos disables analogWrite() functionality on pins 9 and 10,
% whether or not there is a Servo on those pins. On the Mega, up to 12 servos
% can be used without interfering with PWM; use of 12 to 23 servos will
% disable PWM on pins 11 and 12.
% 
% Note that motor shields typically have their own servo connectors,
% For example the Adafruit Motor Shield V1 has 2 servo connector on
% its top left corner, the one labeled "SER1" uses pin #10, 
% while the one labeled "SERVO_2" uses the pin #9.
% 
% Examples:
% servoAttach(a,10); % attaches servo on pin #10
% a.servoAttach(10); % same as above (attaches servo on pin #10)

% send mode, pin and value (1 for attach)
fwrite(a, [54 97+pin 48+1], 'uchar');

%%

% servo detach
function a = servoDetach(a, pin)

% servoDetach(a,pin); detaches a servo from its corresponding pwm pin.
% The first argument, a, is the arduino object. The second argument, 
% pin, is the number of the pin where the servo is attached
% Earlier versions supported only pins 9 and 10, now up to 12 different 
% pins are supported on most Arduino boards, and 48 on the Mega. 
% Note that on boards other than the Mega, using the servos disables 
% analogWrite() functionality on pins 9 and 10, whether or not there 
% is a Servo on those pins. On the Mega, up to 12 servos can be used 
% without interfering with PWM; use of 12 to 23 servos will 
% disable PWM on pins 11 and 12.            
%
% Examples:
% servoDetach(a,10); % detaches a servo attached on pin 10
% a.servoDetach(10); % detaches a servo attached on pin 10

% send mode, pin and value (0 for detach)
fwrite(a, [48+6 97+pin 48+0], 'uchar');

%%
function val = servoRead(a, pin)

% val=servoRead(a,pin); reads the angle of a given servo.
% The first argument, a, is the arduino object.
% The second argument, pin, is the number of the pin where the servo is attached
% Earlier versions supported only pins 9 and 10, now up to 12 different pins are
% supported on most Arduino boards, and 48 on the Mega.
% The returned value is the angle in degrees, typically from 0 to 180.
% 
% Note that this function returns random values in DEMO mode, 
% or when a sketch that does not support servos is running on 
% the Arduino board.
%
% Examples:
% val = servoRead(a, 10); % reads angle from servo on pin #10
% val = a.servoRead(9);   % reads angle from servo on pin #9

% send mode and pin
fwrite(a, [48+7 97+pin], 'uchar');

% get value
val = fscanf(a, '%d');

%%
function servoWrite(a, pin, val)

% servoWrite(a, pin, val); writes an angle on a given servo.
% The first argument, a, is the arduino object.
% The second argument, pin, is the number of the pin where the servo is attached
% Earlier versions supported only pins 9 and 10, now up to 12 different pins are
% supported on most Arduino boards, and 48 on the Mega.
% The third argument is the angle in degrees, typically from 0 to 180.
% 
% Examples:
% servoWrite(a, 10, 45); % rotates servo on pin #10 to 45 degrees
% a.servoWrite(9, 70); % rotates servo on pin #9 to 70 degrees

% send mode, pin and value
fwrite(a, [48+8 97+pin val], 'uchar');

%%
% --- Executes on selection change in ServoChannel_popupmenu.
function ServoChannel_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to ServoChannel_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ServoChannel_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ServoChannel_popupmenu


%%
% --- Executes on slider movement.
function Servo_slider_Callback(hObject, eventdata, handles)
% hObject    handle to Servo_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


servo_channel = get(handles.ServoChannel_popupmenu, 'Value');
servo_angle = round(get(handles.Servo_slider, 'Value'));

set(handles.ServoAngle_edit, 'String', num2str(servo_angle));

a = getappdata(gcf, 'SerialObject');

a = servoAttach(a, servo_channel);

servoWrite(a, servo_channel, servo_angle);

% val = servoRead(a, servo_channel);

% make sure the serial object is stored again because it has changed
setappdata(gcf, 'SerialObject', a);

%%
% --- Executes during object creation, after setting all properties.
function Servo_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Servo_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%%

% --- Executes on button press in ServoUp_pushbutton.
function ServoUp_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ServoUp_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

servo_channel = get(handles.ServoChannel_popupmenu, 'Value');
servo_angle = uint8(str2double(get(handles.ServoUp_edit, 'String')));

set(handles.ServoAngle_edit, 'String', num2str(servo_angle));

a = getappdata(gcf, 'SerialObject');

a = servoAttach(a, servo_channel);

servoWrite(a, servo_channel, servo_angle);

% val = servoRead(a, servo_channel);

set(handles.Servo_slider, 'Value', servo_angle);

% a = servoDetach(a, servo_channel);

% make sure the serial object is stored again because it has changed
setappdata(gcf, 'SerialObject', a);

%%
% --- Executes on button press in ServoDown_pushbutton.
function ServoDown_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ServoDown_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

servo_channel = get(handles.ServoChannel_popupmenu, 'Value');
servo_angle = uint8(str2double(get(handles.ServoDown_edit, 'String')));

set(handles.ServoAngle_edit, 'String', num2str(servo_angle));

a = getappdata(gcf, 'SerialObject');

a = servoAttach(a, servo_channel);

servoWrite(a, servo_channel, servo_angle);

% val = servoRead(a, servo_channel);

set(handles.Servo_slider, 'Value', servo_angle);

% a = servoDetach(a, servo_channel);

% make sure the serial object is stored again because it has changed
setappdata(gcf, 'SerialObject', a);

%%

function ServoUp_edit_Callback(hObject, eventdata, handles)
% hObject    handle to ServoUp_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ServoUp_edit as text
%        str2double(get(hObject,'String')) returns contents of ServoUp_edit as a
%        double

%%

% --- Executes during object creation, after setting all properties.
function ServoUp_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ServoUp_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%

function ServoDown_edit_Callback(hObject, eventdata, handles)
% hObject    handle to ServoDown_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ServoDown_edit as text
%        str2double(get(hObject,'String')) returns contents of ServoDown_edit as a double

%%
% --- Executes during object creation, after setting all properties.
function ServoDown_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ServoDown_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%
